unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, AppEvnts;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    FBmp_ArroyVverx:TBitmap;
    FBmp_ArroyVniz:TBitmap;
    FBmp_ArroyLeft:TBitmap;
    FBmp_ArroyRight:TBitmap;
    FBmp_PolzunVert:TBitmap;
    FBmp_PolzunHorz:TBitmap;
    FClientInstance:TFarProc;
    FPrevClientProc:TFarProc;
    procedure ScrollBarDraw(Handl:THandle);
    procedure InitBitmap;
    procedure Window_proc(var message: TMessage);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
{$R Resbitmap.RES}

procedure TForm1.ScrollBarDraw(Handl:THandle);
var
  ps:TScrollBarInfo;
  hdc, hbr:cardinal;
  p, p1:TPoint;
begin
 ps.cbSize:=SizeOf(ps);
 If GetScrollBarInfo(Handl, OBJID_VSCROLL, ps) then
 begin
  If (ps.rgstate[0]<>32768) then
  begin
   hdc:=GetWindowDC(Handl);
   p:=ps.rcScrollBar.TopLeft;
   Windows.ScreenToClient(Handl, p);
   p1:=ps.rcScrollBar.BottomRight;
   Windows.ScreenToClient(Handl, p1);
   StretchBlt(hdc, p.X+3, p.Y+1, p1.X-p.X-1, p1.X-p.X-1,
    FBmp_ArroyVverx.Canvas.Handle, 0, 0, FBmp_ArroyVverx.Width,
    FBmp_ArroyVverx.Height, SRCCOPY);
   StretchBlt(hdc, p.X+3, p1.Y-p1.X+p.X+1, p1.X-p.X-1, p1.X-p.X-1,
    FBmp_ArroyVniz.Canvas.Handle, 0, 0, FBmp_ArroyVniz.Width,
    FBmp_ArroyVniz.Height, SRCCOPY);
   If ps.rgstate[0]<>1 then
   begin
    p.X:=ps.rcScrollBar.Left;
    p.Y:=ps.rcScrollBar.Top+ps.xyThumbTop;
    Windows.ScreenToClient(Handl, p);
    p1.X:=ps.rcScrollBar.Right;
    p1.Y:=ps.rcScrollBar.Top+ps.xyThumbBottom;
    Windows.ScreenToClient(Handl, p1);
    StretchBlt(hdc, p.X+2, p.Y+3, p1.X-p.X-1, p1.Y-p.Y-2,
     FBmp_PolzunVert.Canvas.Handle, 0, 0, FBmp_PolzunVert.Width,
     FBmp_PolzunVert.Height, SRCCOPY);
   end;  
   hbr:=CreateSolidBrush($00F3F0EC);
   p:=ps.rcScrollBar.TopLeft;
   p.Y:=p.Y+ps.dxyLineButton;
   Windows.ScreenToClient(Handl, p);
   p1.X:=p.X+ps.dxyLineButton;
   p1.Y:=p.Y+ps.xyThumbTop-ps.dxyLineButton;
   FillRect(hdc, Rect(p.X+2, p.Y+2, p1.X+2, p1.Y+2), hbr);
   p:=ps.rcScrollBar.TopLeft;
   p.Y:=p.Y+ps.xyThumbBottom;
   Windows.ScreenToClient(Handl, p);
   p1:=ps.rcScrollBar.BottomRight;
   p1.Y:=p1.Y-ps.dxyLineButton;
   Windows.ScreenToClient(Handl, p1);
   FillRect(hdc, Rect(p.X+2, p.Y+2, p1.X+2, p1.Y+2), hbr);
   DeleteObject(hbr);
   ReleaseDC(Handl, hdc);
  end;
 end;
 If GetScrollBarInfo(Handl, OBJID_HSCROLL, ps) then
 begin
  If (ps.rgstate[0]<>32768) then
  begin
   hdc:=GetWindowDC(Handl);
   p:=ps.rcScrollBar.TopLeft;
   Windows.ScreenToClient(Handl, p);
   p1:=ps.rcScrollBar.BottomRight;
   Windows.ScreenToClient(Handl, p1);
   StretchBlt(hdc, p.X+2, p.Y+3, p1.Y-p.Y-1, p1.Y-p.Y-1,
    FBmp_ArroyLeft.Canvas.Handle, 0, 0, FBmp_ArroyLeft.Width,
    FBmp_ArroyLeft.Height, SRCCOPY);
   StretchBlt(hdc, p1.X-p1.Y+p.Y+2, p.Y+3, p1.Y-p.Y-1, p1.Y-p.Y-1,
    FBmp_ArroyRight.Canvas.Handle, 0, 0, FBmp_ArroyRight.Width,
    FBmp_ArroyRight.Height, SRCCOPY);
   If ps.rgstate[0]<>1 then
   begin
    p.X:=ps.rcScrollBar.Left+ps.xyThumbTop;
    p.Y:=ps.rcScrollBar.Top;
    Windows.ScreenToClient(Handl, p);
    p1.X:=ps.rcScrollBar.Left+ps.xyThumbBottom;
    p1.Y:=ps.rcScrollBar.Bottom;
    Windows.ScreenToClient(Handl, p1);
    StretchBlt(hdc, p.X+2, p.Y+3, p1.X-p.X-2, p1.Y-p.Y-2,
     FBmp_PolzunHorz.Canvas.Handle, 0, 0, FBmp_PolzunHorz.Width,
     FBmp_PolzunHorz.Height, SRCCOPY);
   end;
   hbr:=CreateSolidBrush($00F3F0EC);
   p:=ps.rcScrollBar.TopLeft;
   p.X:=p.X+ps.dxyLineButton;
   Windows.ScreenToClient(Handl, p);
   p1.X:=p.X+ps.xyThumbTop-ps.dxyLineButton;
   p1.Y:=p.Y+ps.dxyLineButton;
   FillRect(hdc, Rect(p.X+2, p.Y+2, p1.X+2, p1.Y+2), hbr);
   p:=ps.rcScrollBar.TopLeft;
   p.X:=p.X+ps.xyThumbBottom;
   Windows.ScreenToClient(Handl, p);
   p1:=ps.rcScrollBar.BottomRight;
   p1.X:=p1.X-ps.dxyLineButton;
   Windows.ScreenToClient(Handl, p1);
   FillRect(hdc, Rect(p.X+2, p.Y+2, p1.X+2, p1.Y+2), hbr);
   DeleteObject(hbr);
   ReleaseDC(Handl, hdc);
  end;
 end;
end;

procedure TForm1.InitBitmap;
begin
 FBmp_ArroyVverx:=TBitmap.Create;
 FBmp_ArroyVverx.LoadFromResourceName(HInstance, 'BMP_RES_ArroyVverx');
 FBmp_ArroyVniz:=TBitmap.Create;
 FBmp_ArroyVniz.LoadFromResourceName(HInstance, 'BMP_RES_ArroyVniz');
 FBmp_ArroyLeft:=TBitmap.Create;
 FBmp_ArroyLeft.LoadFromResourceName(HInstance, 'BMP_RES_ArroyLeft');
 FBmp_ArroyRight:=TBitmap.Create;
 FBmp_ArroyRight.LoadFromResourceName(HInstance, 'BMP_RES_ArroyRight');
 FBmp_PolzunVert:=TBitmap.Create;
 FBmp_PolzunVert.LoadFromResourceName(HInstance, 'BMP_RES_PolzunVert');
 FBmp_PolzunHorz:=TBitmap.Create;
 FBmp_PolzunHorz.LoadFromResourceName(HInstance, 'BMP_RES_PolzunHorz');
end;

procedure TForm1.Window_proc(var message: TMessage);
begin
 message.Result:=CallWindowProc(FPrevClientProc,
  Memo1.Handle, message.Msg, message.wParam, message.lParam);
 case message.Msg of
  WM_NCPAINT: begin
   ScrollBarDraw(Memo1.Handle);
  end;
  WM_PAINT: begin
   ScrollBarDraw(Memo1.Handle);
  end;
  WM_VSCROLL: begin
   ScrollBarDraw(Memo1.Handle);
  end;
  WM_HSCROLL: begin
   ScrollBarDraw(Memo1.Handle);
  end;
  48435: begin
   ScrollBarDraw(Memo1.Handle);
  end;
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 InitBitmap;
 FClientInstance:=MakeObjectInstance(Window_proc);
 FPrevClientProc:=Pointer(GetWindowLong(Memo1.Handle, GWL_WNDPROC));
 SetWindowLong(Memo1.Handle, GWL_WNDPROC, LongInt(FClientInstance));
end;

end.
